//#####################################################################
// Copyright 2014, Ed Quigley
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __CODIMENSIONAL_INTERSECTION_DRIVER__
#define __CODIMENSIONAL_INTERSECTION_DRIVER__
#include <string>

#include "CODIMENSIONAL_INTERSECTION_EXAMPLE.h"
#include "../Meshing/CODIMENSIONAL_MESHING_3D.h"

namespace PhysBAM
{
template<class TV>
class CODIMENSIONAL_INTERSECTION_DRIVER
{
    typedef typename TV::SCALAR T;
    typedef VECTOR<T,3> TV3;
    typedef VECTOR<int,4> TV_INT4;
public:
    int test;
    T default_thickness;
    CODIMENSIONAL_INTERSECTION_EXAMPLE<TV> example;
    std::string input_filename;

    CODIMENSIONAL_INTERSECTION_DRIVER();
    void Initialize();
    void Initialize_Data();
    void Run_Input_Tests();
    void Execute_Main_Program();
};
}

#endif //__CODIMENSIONAL_INTERSECTION_DRIVER__
