//#####################################################################
// Copyright 2014, Ed Quigley
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __CODIMENSIONAL_INTERSECTION_EXAMPLE__
#define __CODIMENSIONAL_INTERSECTION_EXAMPLE__

#include <PhysBAM_Dynamics/Particles/CODIMENSIONAL_FLUID_PARTICLES.h>
#include <PhysBAM_Geometry/Solids_Geometry/DEFORMABLE_GEOMETRY_COLLECTION.h>
#include <PhysBAM_Geometry/Topology/SEGMENT_MESH.h>
#include <PhysBAM_Geometry/Topology/TETRAHEDRON_MESH.h>
#include <PhysBAM_Geometry/Topology/TRIANGLE_MESH.h>

#include "../Meshing/CODIMENSIONAL_MESH.h"
#include "../Meshing/CODIMENSIONAL_MESH_OBJECT_3D.h"
#include "CODIMENSIONAL_INTERSECTION.h"

namespace PhysBAM
{
template<class TV>
class CODIMENSIONAL_INTERSECTION_EXAMPLE
{
    typedef typename TV::SCALAR T;
    typedef VECTOR<T,2> TV2;
    typedef VECTOR<T,3> TV3;
    typedef VECTOR<T,4> TV4;
    typedef typename TV::template REBIND<int>::TYPE TV_INT;
    typedef VECTOR<int,2> TV_INT2;
    typedef VECTOR<int,3> TV_INT3;
    typedef VECTOR<int,4> TV_INT4;
public:

    CODIMENSIONAL_FLUID_PARTICLES<TV> particles;
    SEGMENT_MESH segment_mesh;
    TRIANGLE_MESH triangle_mesh;
    TETRAHEDRON_MESH tetrahedron_mesh;
    CODIMENSIONAL_MESH codimensional_mesh;
    CODIMENSIONAL_MESH_OBJECT<TV> codimensional_mesh_object;
    CODIMENSIONAL_INTERSECTION<T> codimensional_intersection;
    DEFORMABLE_GEOMETRY_COLLECTION<TV> deformable_geometry_collection;

    CODIMENSIONAL_INTERSECTION_EXAMPLE();
    //typename TV::SCALAR Run_Distance_Test(int element1,bool is_point1,int element2,bool is_point2,bool verbose=false);
    //bool Run_Intersection_Test(int element1,bool is_point1,int element2,bool is_point2,bool verbose=false);
    typename TV::SCALAR Run_Distance_Test(TV_INT4 arg1,TV_INT4 arg2,bool verbose=false);
    bool Run_Intersection_Test(TV_INT4 arg1,TV_INT4 arg2,bool verbose=false);

};
}

#endif //__CODIMENSIONAL_INTERSECTION_EXAMPLE__
