//#####################################################################
// Copyright 2014, Bo Zhu
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __CODIMENSIONAL_HEAT_TRANSFER__
#define __CODIMENSIONAL_HEAT_TRANSFER__
#include <PhysBAM_Geometry/Topology/SEGMENT_MESH.h>
#include <PhysBAM_Geometry/Topology/TRIANGLE_MESH.h>
#include <PhysBAM_Geometry/Topology/TETRAHEDRON_MESH.h>
#include <PhysBAM_Tools/Matrices/MATRIX.h>
#include <PhysBAM_Tools/Matrices/SYMMETRIC_MATRIX_3X3.h>
#include <PhysBAM_Tools/Matrices/SPARSE_MATRIX_FLAT_NXN.h>
#include "../Meshing/CODIMENSIONAL_MESH_OBJECT_3D.h"
#include "../Solver/CODIMENSIONAL_VISCOSITY_FORCE.h"
#include "../Mpi/MPI_CODIMENSIONAL.h"

namespace PhysBAM
{
template<class TV>
class CODIMENSIONAL_HEAT_TRANSFER : public CODIMENSIONAL_VISCOSITY_FORCE<TV>
{
    typedef CODIMENSIONAL_VISCOSITY_FORCE<TV> BASE;
    typedef typename TV::SCALAR T;
    typedef VECTOR<T,2> TV2;typedef VECTOR<T,3> TV3;typedef VECTOR<int,2> TV_INT2;typedef VECTOR<int,3> TV_INT3;typedef VECTOR<int,4> TV_INT4;
    typedef MATRIX<T,TV::m> T_MATRIX;typedef DIAGONAL_MATRIX<T,TV::m> T_DIAGONAL_MATRIX;typedef SYMMETRIC_MATRIX<T,TV::m> T_SYMMETRIC_MATRIX;
public:
    using BASE::codimensional_mesh_object;using BASE::particles;using BASE::segment_mesh;using BASE::triangle_mesh;using BASE::tetrahedron_mesh;
    using BASE::kinematic_viscosity;using BASE::density;using BASE::thickness_scale;using BASE::psi_Ds_on_mesh;using BASE::psi_Ns_on_mesh;using BASE::element_index_in_pressure_samples;using BASE::particle_index_in_velocity_samples;
    using BASE::solver;using BASE::use_constant_extrapolation;using BASE::use_staggered_dof;using BASE::mpi_codim;
    using BASE::Use_Constant_Extrapolation;using BASE::Reset_Solver;using BASE::Update_G;using BASE::Update_M_inv;using BASE::Update_A;
    using BASE::Interpolate_Particle_Attribute_To_Pressure_Sample;

    CODIMENSIONAL_HEAT_TRANSFER(CODIMENSIONAL_MESH_OBJECT<TV>& codimensional_mesh_object_input,MPI_CODIMENSIONAL<TV>* mpi_codim_input=0);
    virtual void Update_Heat_Transfer(ARRAY_VIEW<T>& heat,const T dt,const T time);
};
}
#endif
