//#####################################################################
// Copyright 2014, Ed Quigley
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#ifndef __LADLE_H__
#define __LADLE_H__
#include <PhysBAM_Tools/Interpolation/BSPLINE.h>
#include <PhysBAM_Tools/Matrices/FRAME.h>
#include <PhysBAM_Tools/Matrices/QUATERNION.h>
#include <PhysBAM_Tools/Random_Numbers/RANDOM_NUMBERS.h>
#include <PhysBAM_Tools/Vectors/TWIST.h>
#include <PhysBAM_Solids/PhysBAM_Rigids/Rigid_Bodies/RIGID_BODY.h>
#include "../Viscoelastic/OBJECT.h"

namespace PhysBAM
{
template<class TV>
class LADLE:public OBJECT<TV>
{
    typedef typename TV::SCALAR T;
    typedef OBJECT<TV> BASE;
public:
    enum LADLE_MOTION{CIRCLE,ZIGZAG,COMBO,COMBO2,COMBO2_SLOWMO,COMBO2_SLOWMO_THE_RECKONING,COMBO3_THE_JOURNEY_HOME,COMBO4_A_NEW_HOPE};//these are starting to sound like bad sequel names

    using BASE::motion_bspline_order;using BASE::motion_t;using BASE::motion_X;using BASE::motion_Q;using BASE::motion_X_bspline;using BASE::motion_Q_bspline;
    using BASE::object_frame;using BASE::object_twist;using BASE::rigid_body;
    using BASE::Initialize_Prescribed_Motion;using BASE::Set_Prescribed_Motion_For_Test;using BASE::Add_Prescribed_Motion_Key_Frame;using BASE::Prescribed_Frame;using BASE::Prescribed_Twist;using BASE::Update_Kinematic_Velocities_And_Positions;

    LADLE_MOTION motion_type;
    RANDOM_NUMBERS<T> random;

    LADLE();
    virtual ~LADLE();

    virtual void Set_Prescribed_Motion_For_Test();
    virtual FRAME<TV> Prescribed_Frame(const T time);
};
}
#endif //__LADLE_H__
