//#####################################################################
// Copyright 2014, Bo Zhu
// This file is part of PhysBAM whose distribution is governed by the license contained in the accompanying file PHYSBAM_COPYRIGHT.txt.
//#####################################################################
#include <PhysBAM_Dynamics/Geometry/GENERAL_GEOMETRY_FORWARD.h>
#include <PhysBAM_Dynamics/Particles/PARTICLES_FORWARD.h>
#include <PhysBAM_Dynamics/Read_Write/Particles/READ_WRITE_PARTICLES.h>
#include <PhysBAM_Geometry/Read_Write/Geometry/READ_WRITE_TRIANGULATED_AREA.h>
#include <PhysBAM_Geometry/Read_Write/Geometry/READ_WRITE_STRUCTURE.h>
#include <PhysBAM_Geometry/Read_Write/Geometry/READ_WRITE_RIGID_GEOMETRY_COLLECTION.h>
#include "../Viscoelastic/PAINT_EXAMPLE.h"
using namespace PhysBAM;

template<class TV>
PhysBAM::PAINT_EXAMPLE<TV>::PAINT_EXAMPLE()
    :output_directory(TV::m==2?"output":"output3")
{
}

template<class TV>
void PhysBAM::PAINT_EXAMPLE<TV>::Read_Output_Files(const int frame)
{
    STREAM_TYPE stream_type((T()));
    std::string f=STRING_UTILITIES::string_sprintf("%d",frame);
    std::string file_name=output_directory+"/"+f+"/particles";
    if(FILE_UTILITIES::File_Exists(file_name))FILE_UTILITIES::Read_From_File(stream_type,file_name,fiber.fiber_particles);
    if(fiber.use_guided_fibers) fiber.guided_deformable_geometry_collection.Read(stream_type,output_directory,frame,frame,true,std::string("2"));
    else fiber.deformable_geometry_collection.Read(stream_type,output_directory,frame,frame,true,std::string("2"));
}

template<class TV>
void PhysBAM::PAINT_EXAMPLE<TV>::Write_Output_Files(const int frame)
{
    STREAM_TYPE stream_type((T()));
    std::string f=STRING_UTILITIES::string_sprintf("%d",frame);
    FILE_UTILITIES::Write_To_File(stream_type,output_directory+"/"+f+"/particles",fiber.fiber_particles);
    if(fiber.use_guided_fibers){
        fiber.guided_deformable_geometry_collection.Write(stream_type,output_directory,frame,frame,true,std::string("2"));
        std::string f=STRING_UTILITIES::string_sprintf("%d",frame);
        FILE_UTILITIES::Write_To_File(stream_type,output_directory+"/"+f+"/particles2",fiber.guided_fiber_particles);
    }
    else{
        fiber.deformable_geometry_collection.Write(stream_type,output_directory,frame,frame,true,std::string("2"));
        std::string f=STRING_UTILITIES::string_sprintf("%d",frame);
        FILE_UTILITIES::Write_To_File(stream_type,output_directory+"/"+f+"/particles2",fiber.fiber_particles);
    }
}

template<class TV>
void PhysBAM::PAINT_EXAMPLE<TV>::Set_Length_Scale(const T length_scale)
{
    fiber.length_scale=length_scale;
}

//template class PAINT_EXAMPLE<VECTOR<float,2> >;
template class PAINT_EXAMPLE<VECTOR<float,3> >;
#ifndef COMPILE_WITHOUT_DOUBLE_SUPPORT
//template class PAINT_EXAMPLE<VECTOR<double,2> >;
template class PAINT_EXAMPLE<VECTOR<double,3> >;
#endif